<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "specialty_visit_reason".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SpecialtyVisitReason".
 *
 * Columns in table "specialty_visit_reason" available as properties of the model,
 * followed by relations of table "specialty_visit_reason" available as properties of the model.
 *
 * @property integer $id
 * @property integer $all_specialties
 * @property string $name
 * @property integer $standard_visit_duration
 *
 */
abstract class BaseSpecialtyVisitReason extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'specialty_visit_reason';
    }

    public function rules()
    {
        return array(
            array('visit_reason_id', 'required'),
            array('specialty_id', 'required'),
            array('sub_specialty_id, visit_reason_id', 'numerical', 'integerOnly' => true),
            array('id, visit_reason_id, sub_specialty_id', 'safe', 'on' => 'search'),
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty ID'),
            'visit_reason_id' => Yii::t('app', 'Visit Reason ID'),
        );
    }

    public function relations()
    {
        return array(
            'VisitReason' => array(self::BELONGS_TO, 'VisitReason', 'visit_reason_id'),
            'SubSpecialty' => array(self::BELONGS_TO, 'SubSpecialty', 'sub_specialty_id'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('visit_reason_id', $this->visit_reason_id, true);
        $criteria->compare('sub_specialty_id', $this->sub_specialty_id, true);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize' => 100)));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Visit Reason|Visit Reasons', $n);
    }

}
